﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Drawing2D;

namespace howto_cut_lines
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private List<Point> StartPoints = new List<Point>();
        private List<Point> EndPoints = new List<Point>();

        private bool Drawing = false;
        private Point NewStartPoint, NewEndPoint;

        private void picLines_MouseDown(object sender, MouseEventArgs e)
        {
            Drawing = true;
            NewStartPoint = e.Location;
            NewEndPoint = e.Location;
        }

        private void picLines_MouseMove(object sender, MouseEventArgs e)
        {
            if (!Drawing) return;
            NewEndPoint = e.Location;
            picLines.Refresh();
        }

        private void picLines_MouseUp(object sender, MouseEventArgs e)
        {
            Drawing = false;

            if (NewStartPoint == NewEndPoint) return;

            StartPoints.Add(NewStartPoint);
            EndPoints.Add(NewEndPoint);
            picLines.Refresh();
        }

        private void picLines_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;

            // Draw the previously saved lines.
            Pen bg_pen = null;
            if (chkUseCuts.Checked) bg_pen = new Pen(picLines.BackColor, 8);
            using (Pen fg_pen = new Pen(Color.Blue, 4))
            {
                for (int i = 0; i < StartPoints.Count; i++)
                {
                    DrawLine(e.Graphics, bg_pen, fg_pen,
                        StartPoints[i], EndPoints[i]);
                }

                // Draw the new line if there is one.
                if (Drawing)
                {
                    fg_pen.Color = Color.Red;
                    DrawLine(e.Graphics, bg_pen, fg_pen,
                        NewStartPoint, NewEndPoint);
                }
            }
            if (bg_pen != null) bg_pen.Dispose();
        }

        // Draw a line segment in the indicated color.
        private void DrawLine(Graphics gr, Pen bg_pen, Pen fg_pen,
            Point start_point, Point end_point)
        {
            if (bg_pen != null)
                gr.DrawLine(bg_pen, start_point, end_point);
            gr.DrawLine(fg_pen, start_point, end_point);
        }

        private void chkUseCuts_CheckedChanged(object sender, EventArgs e)
        {
            picLines.Refresh();
        }
    }
}
